﻿using Simbir.Market.Account.Models;
using Simbir.Market.Account.Services.DTO;

namespace Simbir.Market.Account.Services
{
    public interface IUserService
    {
        Task<long> CreateAsync(UserCreateDTO userDTO);
        Task<long> CreateByAdminAsync(UserCreateByAdminDTO userDTO);
        Task<long> AuthenticateAsync(string username, string password);
        Task<bool> LogoutAsync(long userId);
        Task<User> GetByIdAsync(long userId, bool? isDeleted, bool? isLogin);
        Task<AccountMeInfoDTO> GetMeInfoByIdAsync(long userId);
        Task<AccountInformationListDTO> GetAllAsync(int from, int count);
        Task UpdateAsync(long userId, UserUpdateDTO user);
        Task DeleteAsync(long userId);
        Task<bool> DoesUserExistAsync(long userId);
        Task UpdateUserAsync(long userId, UserUpdateByAdminDTO userDTO);
        Task<string[]> GetUserRolesByIdAsync(long id);
    }
}