﻿using System.ComponentModel.DataAnnotations;

namespace Simbir.Market.Market.Controllers.DTO;

public class ProductUpdateRequest
{
    [Required]
    [StringLength(512, ErrorMessage = "Название товара должно быть не больше 512 символов в длину")]
    public string Name { get; set; }
    [Required]
    [StringLength(2000, ErrorMessage = "Описание товара должен быть не больше 2000 символов в длину")]
    public string Description { get; set; }
    [Required]
    [Range(1, double.MaxValue, ErrorMessage = "Стоимость товара должна быть больше {1}")]
    public double Price { get; set; }
    [Required]
    public List<string> Tags { get; set; } = new List<string>();
}
