﻿using Simbir.Market.Market.Controllers.DTO;
using Simbir.Market.Market.Services.DTO;

namespace Simbir.Market.Market.Services
{
    public interface IProductService
    {
        Task<ProductDetailedInfoDTO> GetProductByIdAsync(long id);
        Task<long> CreateProductAsync(ProductCreateRequest request, string accessToken);
        Task UpdateProductAsync(long id, ProductUpdateRequest request, string acessToken);
        Task DeleteProductByIdAsync(long id, string accessToken);
        Task IncreaseProductAmountByIdAsync(long id, ProductAmountRequest request, string accessToken);
        Task DecreaseProductAmountByIdAsync(long id, ProductAmountRequest request, string accessToken);
        Task<List<ProductInformationDTO>> GetAllProductsAsync(ProductListFilterDTO filter);
    }
}
