﻿using Microsoft.EntityFrameworkCore;
using Simbir.Market.Payment.Controllers.DTO;
using Simbir.Market.Payment.Models;
using Simbir.Market.Payment.Data;
using Simbir.Market.Payment.Exceptions;

namespace Simbir.Market.Payment.Services
{
    public class PaymentService : IPaymentService
    {
        private readonly DataContext _context;

        public PaymentService(DataContext context)
        {
            _context = context;
        }

        public async Task<CreatePaymentResponse> CreatePaymentAsync(CreatePaymentRequest request)
        {
            var payment = new PaymentEntity
            {
                Price = request.Price,
                PurchaseId = request.PurchaseId
            };

            await _context.Payments.AddAsync(payment);
            await _context.SaveChangesAsync();

            var response = new CreatePaymentResponse
            {
                PaymentId = payment.Id
            };

            return response;
        }

        public Task PayAsync(long paymentId, PayRequest request)
        {
            return Task.CompletedTask;
        }
    }
}
