﻿using AutoMapper;
using Simbir.Market.Purchase.Controllers.DTO;
using Simbir.Market.Purchase.Models;
using Simbir.Market.Purchase.Services.DTO;

namespace Simbir.Market.Purchase.AutoMapper
{
    public class AutoMapperProfile : Profile
    {
        public AutoMapperProfile()
        {
            CreateMap<PurchaseCreateRequest, PurchaseEntity>()
                .ForMember(entity => entity.Id, opt => opt.Ignore())
                .ForMember(entity => entity.TotalCost, opt => opt.Ignore())
                .ForMember(entity => entity.Status, opt => opt.Ignore())
                .ForMember(entity => entity.PaymentId, opt => opt.Ignore())
                .ForMember(entity => entity.UserId, opt => opt.Ignore());

            CreateMap<PurchaseEntity, PurchaseHistoryInfoDTO>()
                .ForMember(dto => dto.Status, m => m.MapFrom(entity => Enum.GetName(typeof(PurchaseStatus), entity.Status)));
        }
    }
}
