﻿using Domain;
using MassTransit;
using Simbir.Market.Purchase.Services;
using System.Text;

namespace Simbir.Market.Purchase.Consumers
{
    public class PaymentConsumer : IConsumer<PaymentMessage>
    {
        private readonly IPurchaseService _purchaseService;

        public PaymentConsumer(IPurchaseService purchaseService)
        {
            _purchaseService = purchaseService;
        }

        public async Task Consume(ConsumeContext<PaymentMessage> context)
        {
            _purchaseService.ClosePurchaseAsync(context.Message.PaymentId);
        }
    }
}
